from sys import stdin, argv
from collections import defaultdict
from string import ascii_lowercase
from random import choice

freq = defaultdict(int)
for row in open(argv[1],'r').readlines(): freq[ row[:4] ] = int( row[5:] )

max_context = int(argv[2])
assert 0 <= max_context <= 3

def dalsie_pismeno(kontext):
    # cvicenie pre citatela: toto implementovat menej lenivo a efektivnejsie :)
    total = ''
    for x in ascii_lowercase+' ': total += x * freq[kontext+x]
    if total=='': return ' '
    return choice(total)

output = choice( [ x for x in freq if freq[x]>50 ] ) # zacni z nahodnej nie-uplne-zlej stvorice znakov -- tu by tiez bolo krajsie brat do uvahy frekvencie
while len(output)<500:
    if max_context==0: kontext=''
    else: kontext=output[-max_context:]
    output += dalsie_pismeno(kontext)

print(output)
